线段树(端点更新) hdu-4521 小明系列问题——小明序列

题目链接:

http://acm.hdu.edu.cn/showproblem.php?pid=4521

题目意思:

求出相邻位置之差大于d的最长递增子序列的长度。

解题思路:

由于n有10^5,用普通的dp,算法时间复杂度为o(n^2),肯定会超时。

所以用线段树进行优化。线段树维护的是区间内包含某点的最大满足条件的长度,叶子节点以该元素结尾,最长长度。

至于相邻两项隔d个位置,求dp[i]时,我们只把dp[i-d-1]更新至线段树中,然后在这颗线段树中找最大的个数,这也是线段树的一个很重要的应用方面。

线段树的功能:查找区间内最大值的优化。

代码:

#include<iostream>
#include<cmath>
#include<cstdio>
#include<cstdlib>
#include<string>
#include<cstring>
#include<algorithm>
#include<vector>
#include<map>
#include<stack>
#include<list>
#include<queue>
#define eps 1e-6
#define INF (1<<30)
#define PI acos(-1.0)
using namespace std;

#define lson l,m,rt<<1
#define rson m+1,r,(rt<<1)|1
#define N (int)(1e5+5)

int num[4*N],save[N],dp[N];

void pushup(int rt) //向上更新
{
   num[rt]=max(num[rt<<1],num[rt<<1|1]);
   return ;
}

void build(int l,int r,int rt)
{
   num[rt]=0;
   if(l==r)
      return ;
   int m=(l+r)>>1;
   build(lson);
   build(rson);
   return ;
}

void update(int t,int v,int l,int r,int rt) //端点更新
{
   if(l==r)
   {
      num[rt]=max(num[rt],v);
      return ;
   }
   int m=(l+r)>>1;

   if(t<=m)
      update(t,v,lson);
   else
      update(t,v,rson);
   pushup(rt);

}

int query(int L,int R,int l,int r,int rt)//找出L,R区间内最大的长度
{
   if(L<=l&&R>=r)
      return num[rt];
   int m=(l+r)>>1;

   int Max=0;
   if(L<=m)
      Max=max(Max,query(L,R,lson));
   if(R>m)
      Max=max(Max,query(L,R,rson));

   return Max;
}
int main()
{
   int n,d;

   while(scanf("%d%d",&n,&d)!=EOF)
   {
      int Max=0;
      for(int i=1;i<=n;i++)
      {
         scanf("%d",&save[i]);
         Max=max(Max,save[i]);
      }
      build(0,Max,1);
      int ans=0;
      for(int i=1;i<=n;i++)
      {
         if(i-d-1>=1)
            update(save[i-d-1],dp[i-d-1],0,Max,1); //这是关键,只把i-d-1前面的更新至线段树中
         if(save[i]==0)
            dp[i]=1;
         else
            dp[i]=query(0,save[i]-1,0,Max,1)+1;
         ans=max(dp[i],ans);
      }
      printf("%d\n",ans);
   }
   return 0;
}






你可能感兴趣的:(线段树(端点更新) hdu-4521 小明系列问题——小明序列)